* program that gets instruments for both broad and wage income;
* at the same time;


/*
USE TRANSTAL.SAS PROGRAM TO DES-XPORT TALL

libname new '/scratch/saez';
libname trans XPORT '/scratch/saez/tall';
proc copy in=trans out=new;
run;
*/


*;
*;
*      d1tall;
*; 
*;
*;






 /* this program creates tall2 by merging tall and
the feldst.dat  or gruber.dat file by FLPDYR and ID */

OPTIONS errors=100;

libname bobo '/scratch/saez';



DATA bobo.talluse;
set bobo.tall;
ARRAY tallar (391) agex--E90_110;
DO i = 1 TO 391;
   IF tallar(i)=. THEN tallar(i)=0;
END;

if FLPDYR=79 then PCE=0.527; * creep inflation;
if FLPDYR=80 then PCE=0.582; * creep inflation;
if FLPDYR=81 then PCE=0.637;
if FLPDYR=82 then PCE=0.674;
if FLPDYR=83 then PCE=0.705;
if FLPDYR=84 then PCE=0.731;
if FLPDYR=85 then PCE=0.758;
if FLPDYR=86 then PCE=0.780;
if FLPDYR=87 then PCE=0.810;
if FLPDYR=88 then PCE=0.843; * careful here for feldst;
if FLPDYR=89 then PCE=0.884;
if FLPDYR=90 then PCE=0.929;

IF flpdyr=84 OR flpdyr=85 OR flpdyr=86 THEN
ttladj=moving+empexp+iraded+keogh+penlty+almpd+secern;
IF flpdyr=87 THEN
ttladj=empexp+iraded+irasec+keogh+penlty+almpd;
IF flpdyr>=88 THEN
ttladj=empexp+iraded+irasec+keogh+penlty+almpd+health;
IF flpdyr<=80 OR flpdyr=82 OR flpdyr=83 THEN 
broad=agi+ttladj+divrec-divagi+1.5*(cgdist+cgagi)+ui-uiagi;
IF flpdyr=81 THEN 
broad=agi+ttladj+divrec+inty-divint+1.5*(cgdist+cgagi)+ui-uiagi;
IF flpdyr=84 OR flpdyr=85 OR flpdyr=86 THEN 
broad=agi+ttladj+divrec-divagi+1.5*(cgdist+cgagi)+ui-uiagi-ssagi;
IF flpdyr>=87 THEN 
broad=agi+ttladj-ssagi;
RUN;





DATA bobo.talluse;
set bobo.talluse
 (keep = broad pce

flpdyr id year mars state txrt txnt txst xtot
 

agi wages inty intmb divagi divint 
stxref almrec schedc divrec divexc cgagi cgdist farm supgn
taxira totpen txpen schede piar penagi
iragi other taxoth ftpen schedep cxncgl cltgi uiagi ui gssb
ssagi othery


empexp iraded irasec keogh penlty
almpd secern health disabx ttladj frgn housed othadj


eic balnce

txcred

mintax almtax txliab inctax taxaft

itded nonit tabley exempt newtxy oldtxy zba tax regtax margin
taxbc nystax oystax 

totitm 
sey mxttly mxnety mxpref mrrdpy mrrdsy dweght

agex agexb 
party partl sbtly sbtlss esty estlss rentyl ryltyl
frent passl npassl smbloss sbnpls
partny smbpy smbnpy passy npassy);
 
run;
PROC SORT data=bobo.talluse;
by FLPDYR ID;
run; 



DATA bobo.gruber;
INFILE '/scratch/saez/wag1.tab';
INPUT FLPDYR ID TAXLIA TAXF0 TAXS0 WRATEF0 WRATES0 TAXF1 TAXS1  WRATEF1 WRATES1
STATEB;
FLPDYR=FLPDYR-1900;
run;
PROC SORT data=bobo.gruber;
by FLPDYR ID;
run;

DATA bobo.tall2;
MERGE bobo.gruber bobo.talluse;
by FLPDYR ID;
run;


DATA bobo.gruber;
INFILE '/scratch/saez/bro1.tab';
INPUT FLPDYR ID TAXLIAB TAXF0B TAXS0B RATEF0 RATES0 TAXF1B TAXS1B 
 RATEF1 RATES1 STATEBB;
FLPDYR=FLPDYR-1900;
run;
PROC SORT data=bobo.gruber;
by FLPDYR ID;
run;

DATA bobo.tall2;
MERGE bobo.gruber bobo.tall2;
by FLPDYR ID;
run;


DATA bobo.tall2;
SET  bobo.tall2;
DROP stateb taxliab taxf0b taxs0b taxf1b taxs1b statebb;
RUN;


DATA bobo.subset4;
set bobo.tall2;
if ID/50-ROUND(ID/50)=0;
run;





 /* this program creates tall79 to tall90 and dtall82 to dtall90
*/

libname bobo '/scratch/saez';


DATA bobo.tall79 bobo.tall80 bobo.tall81 bobo.tall82 bobo.tall83 bobo.tall84 bobo.tall85 bobo.tall86 bobo.tall87 bobo.tall88 bobo.tall89 bobo.tall90 ;
SET bobo.tall2;
IF FLPDYR=79 THEN output bobo.tall79;
IF FLPDYR=80 THEN output bobo.tall80;
IF FLPDYR=81 THEN output bobo.tall81;
IF FLPDYR=82 THEN output bobo.tall82;
IF FLPDYR=83 THEN output bobo.tall83;
IF FLPDYR=84 THEN output bobo.tall84;
IF FLPDYR=85 THEN output bobo.tall85;
IF FLPDYR=86 THEN output bobo.tall86;
IF FLPDYR=87 THEN output bobo.tall87;
IF FLPDYR=88 THEN output bobo.tall88;
IF FLPDYR=89 THEN output bobo.tall89;
IF FLPDYR=90 THEN output bobo.tall90;
RUN; 

DATA bobo.dtall80;
SET bobo.tall80  (RENAME = ( 
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12
 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall81;
SET bobo.tall81  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall82;
SET bobo.tall82  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall83;
SET bobo.tall83  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall84;
SET bobo.tall84  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall85;
SET bobo.tall85  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall86;
SET bobo.tall86  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall87;
SET bobo.tall87  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall88;
SET bobo.tall88  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall89;
SET bobo.tall89  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall90;
SET bobo.tall90  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;


 /* this program creates d1tall one year lag  */

libname bobo '/scratch/saez';


DATA bobo.d1tall80;
MERGE bobo.tall79 (IN=in1) bobo.dtall80 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d1tall81;
MERGE bobo.tall80 (IN=in1) bobo.dtall81 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d1tall82;
MERGE bobo.tall81 (IN=in1) bobo.dtall82 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d1tall83;
MERGE bobo.tall82 (IN=in1) bobo.dtall83 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d1tall84;
MERGE bobo.tall83 (IN=in1) bobo.dtall84 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d1tall85;
MERGE bobo.tall84 (IN=in1) bobo.dtall85 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d1tall86;
MERGE bobo.tall85 (IN=in1) bobo.dtall86 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d1tall87;
MERGE bobo.tall86 (IN=in1) bobo.dtall87 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d1tall88;
MERGE bobo.tall87 (IN=in1) bobo.dtall88 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d1tall89;
MERGE bobo.tall88 (IN=in1) bobo.dtall89 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d1tall90;
MERGE bobo.tall89 (IN=in1) bobo.dtall90 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;


DATA bobo.d1tall;
SET bobo.d1tall80 bobo.d1tall81 bobo.d1tall82 bobo.d1tall83 bobo.d1tall84
 bobo.d1tall85 bobo.d1tall86 bobo.d1tall87 bobo.d1tall88 bobo.d1tall89
 bobo.d1tall90;
IF mars=1 THEN mrs1=1;
ELSE mrs1=0;
IF mars=2 THEN mrs2=1;
ELSE mrs2=0;
IF mars>2 THEN mrs3=1;
ELSE mrs3=0;

IF flpdyr=79 THEN year79=1;
ELSE year79=0;
IF flpdyr=80 THEN year80=1;
ELSE year80=0;
IF flpdyr=81 THEN year81=1;
ELSE year81=0;
IF flpdyr=82 THEN year82=1;
ELSE year82=0;
IF flpdyr=83 THEN year83=1;
ELSE year83=0;
IF flpdyr=84 THEN year84=1;
ELSE year84=0;
IF flpdyr=85 THEN year85=1;
ELSE year85=0;
IF flpdyr=86 THEN year86=1;
ELSE year86=0;
IF flpdyr=87 THEN year87=1;
ELSE year87=0;
IF flpdyr=88 THEN year88=1;
ELSE year88=0;
IF flpdyr=89 THEN year89=1;
ELSE year89=0;


wagesr=wages/pce;
wages2r=wages2/pce2;
lnwag=LOG(wagesr);
dlogw=LOG(wages2r/wagesr);

broadr=broad/pce;
broad2r=broad2/pce2;
lnbroad=LOG(broadr);
dlogb=LOG(broad2r/broadr);


incefp=
LOG((broadr-(taxf1+taxs1)/pce)/(broadr-(taxf0+taxs0)/pce));
fincefp=
LOG((broadr-(taxf1)/pce)/(broadr-(taxf0)/pce));


inceff=
LOG((broad2r-(taxf02+taxs02)/pce2)/(broadr-(taxf0+taxs0)/pce));
finceff=
LOG((broad2r-(taxf02)/pce2)/(broadr-(taxf0)/pce));

incefp2=(-(taxf1+taxs1)/pce+(taxf0+taxs0)/pce)/broadr;
inceff2=(broad2r-(taxf02+taxs02)/pce2-broadr+(taxf0+taxs0)/pce)/broadr;

IF flpdyr<=80 OR flpdyr=82 OR flpdyr=83 THEN 
broadn=agi+ttladj+divrec-divagi+ui-uiagi-cgagi-cgdist;
IF flpdyr=81 THEN 
broadn=agi+ttladj+divrec+inty-divint+ui-uiagi-cgagi-cgdist;
IF flpdyr=84 OR flpdyr=85 OR flpdyr=86 THEN 
broadn=agi+ttladj+divrec-divagi-ssagi+ui-uiagi-cgagi-cgdist;
IF flpdyr>=87 THEN 
broadn=agi+ttladj-ssagi-cgagi-cgdist;

IF flpdyr2<=80 OR flpdyr2=82 OR flpdyr2=83 THEN 
broadn2=agi2+ttladj2+divrec2-divagi2+ui2-uiagi2-cgagi2-cgdist2;
IF flpdyr2=81 THEN 
broadn2=agi2+ttladj2+divrec2+inty2-divint2+ui2-uiagi2-cgagi2-cgdist2;
IF flpdyr2=84 OR flpdyr2=85 OR flpdyr2=86 THEN 
broadn2=agi2+ttladj2+divrec2-divagi2-ssagi2+ui2-uiagi2-cgagi2-cgdist2;
IF flpdyr2>=87 THEN 
broadn2=agi2+ttladj2-ssagi2-cgagi2-cgdist2;

fincbis=-taxf1+taxf0;
incbis=-taxf1-taxs1+taxf0+taxs0;


dlogbr=log(broadn2*pce/(broadn*pce2));
logbr=log(broadn/pce);

newtxr=newtxy/pce;
newtxr2=newtxr**2;
newtxr3=newtxr**3;
newtxr4=newtxr**4;
newtxr5=newtxr**5;


broad2=broadn**2;
broad3=broadn**3;
broad4=broadn**4;
broad5=broadn**5;


dmargp=LOG((100-ratef1-rates1)/(100-ratef0-rates0));
dmargt=LOG((100-ratef02-rates02)/(100-ratef0-rates0)); 
fdmargp=LOG((100-ratef1)/(100-ratef0));
fdmargt=LOG((100-ratef02)/(100-ratef0)); 


wdmargp=LOG((100-wratef1-wrates1)/(100-wratef0-wrates0));
wdmargt=LOG((100-wratef02-wrates02)/(100-wratef0-wrates0)); 
wfdmargp=LOG((100-wratef1)/(100-wratef0));
wfdmargt=LOG((100-wratef02)/(100-wratef0)); 
RUN;

DATA bobo.d1subset;
set bobo.d1tall;
if ID/50-ROUND(ID/50)=0;
run;






*;
*;
*      d2tall;
*; 
*;
*;


 /* this program creates tall2 by merging tall and
the feldst.dat  or gruber.dat file by FLPDYR and ID */

OPTIONS errors=100;

libname bobo '/scratch/saez';
DATA bobo.gruber;
INFILE '/scratch/saez/wag2.tab';
INPUT FLPDYR ID TAXLIA TAXF0 TAXS0 WRATEF0 WRATES0 TAXF1 TAXS1  WRATEF1 WRATES1
STATEB;
FLPDYR=FLPDYR-1900;
run;
PROC SORT data=bobo.gruber;
by FLPDYR ID;
run;

DATA bobo.tall2;
MERGE bobo.gruber bobo.talluse;
by FLPDYR ID;
run;


DATA bobo.gruber;
INFILE '/scratch/saez/bro2.tab';
INPUT FLPDYR ID TAXLIAB TAXF0B TAXS0B RATEF0 RATES0 TAXF1B TAXS1B 
 RATEF1 RATES1 STATEBB;
FLPDYR=FLPDYR-1900;
run;
PROC SORT data=bobo.gruber;
by FLPDYR ID;
run;

DATA bobo.tall2;
MERGE bobo.gruber bobo.tall2;
by FLPDYR ID;
run;

DATA bobo.tall2;
SET  bobo.tall2;
DROP stateb taxliab taxf0b taxs0b taxf1b taxs1b statebb;
RUN;

DATA bobo.subset4;
set bobo.tall2;
if ID/50-ROUND(ID/50)=0;
run;





 /* this program creates tall79 to tall90 and dtall82 to dtall90
*/

libname bobo '/scratch/saez';


DATA bobo.tall79 bobo.tall80 bobo.tall81 bobo.tall82 bobo.tall83 bobo.tall84 bobo.tall85 bobo.tall86 bobo.tall87 bobo.tall88 bobo.tall89 bobo.tall90 ;
SET bobo.tall2;
IF FLPDYR=79 THEN output bobo.tall79;
IF FLPDYR=80 THEN output bobo.tall80;
IF FLPDYR=81 THEN output bobo.tall81;
IF FLPDYR=82 THEN output bobo.tall82;
IF FLPDYR=83 THEN output bobo.tall83;
IF FLPDYR=84 THEN output bobo.tall84;
IF FLPDYR=85 THEN output bobo.tall85;
IF FLPDYR=86 THEN output bobo.tall86;
IF FLPDYR=87 THEN output bobo.tall87;
IF FLPDYR=88 THEN output bobo.tall88;
IF FLPDYR=89 THEN output bobo.tall89;
IF FLPDYR=90 THEN output bobo.tall90;
RUN; 

DATA bobo.dtall80;
SET bobo.tall80  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall81;
SET bobo.tall81  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall82;
SET bobo.tall82  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall83;
SET bobo.tall83  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall84;
SET bobo.tall84  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall85;
SET bobo.tall85  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall86;
SET bobo.tall86  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall87;
SET bobo.tall87  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall88;
SET bobo.tall88  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall89;
SET bobo.tall89  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall90;
SET bobo.tall90  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;




 /* this program creates d2tall one year lag  */

libname bobo '/scratch/saez';


 
DATA bobo.d2tall81;
MERGE bobo.tall79 (IN=in1) bobo.dtall81 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d2tall82;
MERGE bobo.tall80 (IN=in1) bobo.dtall82 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d2tall83;
MERGE bobo.tall81 (IN=in1) bobo.dtall83 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d2tall84;
MERGE bobo.tall82 (IN=in1) bobo.dtall84 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d2tall85;
MERGE bobo.tall83 (IN=in1) bobo.dtall85 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d2tall86;
MERGE bobo.tall84 (IN=in1) bobo.dtall86 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d2tall87;
MERGE bobo.tall85 (IN=in1) bobo.dtall87 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d2tall88;
MERGE bobo.tall86 (IN=in1) bobo.dtall88 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d2tall89;
MERGE bobo.tall87 (IN=in1) bobo.dtall89 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
 
DATA bobo.d2tall90;
MERGE bobo.tall88 (IN=in1) bobo.dtall90 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;


DATA bobo.d2tall;
SET  bobo.d2tall81 bobo.d2tall82 bobo.d2tall83 bobo.d2tall84
 bobo.d2tall85 bobo.d2tall86 bobo.d2tall87 bobo.d2tall88 bobo.d2tall89
 bobo.d2tall90;
IF mars=1 THEN mrs1=1;
ELSE mrs1=0;
IF mars=2 THEN mrs2=1;
ELSE mrs2=0;
IF mars>2 THEN mrs3=1;
ELSE mrs3=0;

IF flpdyr=79 THEN year79=1;
ELSE year79=0;
IF flpdyr=80 THEN year80=1;
ELSE year80=0;
IF flpdyr=81 THEN year81=1;
ELSE year81=0;
IF flpdyr=82 THEN year82=1;
ELSE year82=0;
IF flpdyr=83 THEN year83=1;
ELSE year83=0;
IF flpdyr=84 THEN year84=1;
ELSE year84=0;
IF flpdyr=85 THEN year85=1;
ELSE year85=0;
IF flpdyr=86 THEN year86=1;
ELSE year86=0;
IF flpdyr=87 THEN year87=1;
ELSE year87=0;
IF flpdyr=88 THEN year88=1;
ELSE year88=0;
IF flpdyr=89 THEN year89=1;
ELSE year89=0;

wagesr=wages/pce;
wages2r=wages2/pce2;
lnwag=LOG(wagesr);
dlogw=LOG(wages2r/wagesr);

broadr=broad/pce;
broad2r=broad2/pce2;
lnbroad=LOG(broadr);
dlogb=LOG(broad2r/broadr);


incefp=
LOG((broadr-(taxf1+taxs1)/pce)/(broadr-(taxf0+taxs0)/pce));
fincefp=
LOG((broadr-(taxf1)/pce)/(broadr-(taxf0)/pce));


inceff=
LOG((broad2r-(taxf02+taxs02)/pce2)/(broadr-(taxf0+taxs0)/pce));
finceff=
LOG((broad2r-(taxf02)/pce2)/(broadr-(taxf0)/pce));

incefp2=(-(taxf1+taxs1)/pce+(taxf0+taxs0)/pce)/broadr;
inceff2=(broad2r-(taxf02+taxs02)/pce2-broadr+(taxf0+taxs0)/pce)/broadr;

IF flpdyr<=80 OR flpdyr=82 OR flpdyr=83 THEN 
broadn=agi+ttladj+divrec-divagi+ui-uiagi-cgagi-cgdist;
IF flpdyr=81 THEN 
broadn=agi+ttladj+divrec+inty-divint+ui-uiagi-cgagi-cgdist;
IF flpdyr=84 OR flpdyr=85 OR flpdyr=86 THEN 
broadn=agi+ttladj+divrec-divagi-ssagi+ui-uiagi-cgagi-cgdist;
IF flpdyr>=87 THEN 
broadn=agi+ttladj-ssagi-cgagi-cgdist;

IF flpdyr2<=80 OR flpdyr2=82 OR flpdyr2=83 THEN 
broadn2=agi2+ttladj2+divrec2-divagi2+ui2-uiagi2-cgagi2-cgdist2;
IF flpdyr2=81 THEN 
broadn2=agi2+ttladj2+divrec2+inty2-divint2+ui2-uiagi2-cgagi2-cgdist2;
IF flpdyr2=84 OR flpdyr2=85 OR flpdyr2=86 THEN 
broadn2=agi2+ttladj2+divrec2-divagi2-ssagi2+ui2-uiagi2-cgagi2-cgdist2;
IF flpdyr2>=87 THEN 
broadn2=agi2+ttladj2-ssagi2-cgagi2-cgdist2;

fincbis=-taxf1+taxf0;
incbis=-taxf1-taxs1+taxf0+taxs0;


dlogbr=log(broadn2*pce/(broadn*pce2));
logbr=log(broadn/pce);


newtxr=newtxy/pce;
newtxr2=newtxr**2;
newtxr3=newtxr**3;
newtxr4=newtxr**4;
newtxr5=newtxr**5;


broad2=broadn**2;
broad3=broadn**3;
broad4=broadn**4;
broad5=broadn**5;


dmargp=LOG((100-ratef1-rates1)/(100-ratef0-rates0));
dmargt=LOG((100-ratef02-rates02)/(100-ratef0-rates0)); 
fdmargp=LOG((100-ratef1)/(100-ratef0));
fdmargt=LOG((100-ratef02)/(100-ratef0)); 

wdmargp=LOG((100-wratef1-wrates1)/(100-wratef0-wrates0));
wdmargt=LOG((100-wratef02-wrates02)/(100-wratef0-wrates0)); 
wfdmargp=LOG((100-wratef1)/(100-wratef0));
wfdmargt=LOG((100-wratef02)/(100-wratef0)); 
RUN;


DATA bobo.d2subset;
set bobo.d2tall;
if ID/50-ROUND(ID/50)=0;
run;





*;
*;
*      d3tall;
*; 
*;
*;


 /* this program creates tall2 by merging tall and
the feldst.dat  or gruber.dat file by FLPDYR and ID */

OPTIONS errors=100;

libname bobo '/scratch/saez';
DATA bobo.gruber;
INFILE '/scratch/saez/wag3.tab';
INPUT FLPDYR ID TAXLIA TAXF0 TAXS0 WRATEF0 WRATES0 TAXF1 TAXS1  WRATEF1 WRATES1
STATEB;
FLPDYR=FLPDYR-1900;
run;
PROC SORT data=bobo.gruber;
by FLPDYR ID;
run;

DATA bobo.tall2;
MERGE bobo.gruber bobo.talluse;
by FLPDYR ID;
run;


DATA bobo.gruber;
INFILE '/scratch/saez/bro3.tab';
INPUT FLPDYR ID TAXLIAB TAXF0B TAXS0B RATEF0 RATES0 TAXF1B TAXS1B 
 RATEF1 RATES1 STATEBB;
FLPDYR=FLPDYR-1900;
run;
PROC SORT data=bobo.gruber;
by FLPDYR ID;
run;

DATA bobo.tall2;
MERGE bobo.gruber bobo.tall2;
by FLPDYR ID;
run;

DATA bobo.tall2;
SET  bobo.tall2;
DROP stateb taxliab taxf0b taxs0b taxf1b taxs1b statebb;
RUN;

DATA bobo.subset4;
set bobo.tall2;
if ID/50-ROUND(ID/50)=0;
run;




 /* this program creates tall79 to tall90 and dtall82 to dtall90
*/

libname bobo '/scratch/saez';


DATA bobo.tall79 bobo.tall80 bobo.tall81 bobo.tall82 bobo.tall83 bobo.tall84 bobo.tall85 bobo.tall86 bobo.tall87 bobo.tall88 bobo.tall89 bobo.tall90 ;
SET bobo.tall2;
IF FLPDYR=79 THEN output bobo.tall79;
IF FLPDYR=80 THEN output bobo.tall80;
IF FLPDYR=81 THEN output bobo.tall81;
IF FLPDYR=82 THEN output bobo.tall82;
IF FLPDYR=83 THEN output bobo.tall83;
IF FLPDYR=84 THEN output bobo.tall84;
IF FLPDYR=85 THEN output bobo.tall85;
IF FLPDYR=86 THEN output bobo.tall86;
IF FLPDYR=87 THEN output bobo.tall87;
IF FLPDYR=88 THEN output bobo.tall88;
IF FLPDYR=89 THEN output bobo.tall89;
IF FLPDYR=90 THEN output bobo.tall90;
RUN; 

DATA bobo.dtall80;
SET bobo.tall80  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall81;
SET bobo.tall81  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall82;
SET bobo.tall82  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall83;
SET bobo.tall83  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall84;
SET bobo.tall84  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall85;
SET bobo.tall85  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall86;
SET bobo.tall86  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall87;
SET bobo.tall87  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2  broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall88;
SET bobo.tall88  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall89;
SET bobo.tall89  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;

DATA bobo.dtall90;
SET bobo.tall90  (RENAME = (
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12 taxlia=taxlia2 

pce=pce2 broad=broad2
 flpdyr=flpdyr2 id=id  year=year2
 mars=mars2 state=state2 txrt=txrt2 txnt=txnt2 txst=txst2 xtot=xtot2
 
agi=agi2 wages=wages2 inty=inty2 intmb=intmb2 divagi=divagi2 divint=divint2 
stxref=stxref2 almrec=almrec2 schedc=schedc2 divrec=divrec2
 divexc=divexc2 cgagi=cgagi2 cgdist=cgdist2 farm=farm2 supgn=supgn2
taxira=taxira2 totpen=totpen2 txpen=txpen2
 schede=schede2 piar=piar2 penagi=penagi2
iragi=iragi2 other=other2 taxoth=taxoth2 ftpen=ftpen2
 schedep=schedep2 cxncgl=cxncgl2 cltgi=cltgi2 uiagi=uiagi2
 ui=ui2 gssb=gssb2 ssagi=ssagi2 othery=othery2

empexp=empexp2 iraded=iraded2 irasec=irasec2 keogh=keogh2 penlty=penlty2
almpd=almpd2 secern=secern2 health=health2 disabx=disabx2
 ttladj=ttladj2 frgn=frgn2 housed=housed2 othadj=othadj2

eic=eic2 balnce=balnce2

txcred=txcred2

mintax=mintax2 almtax=almtax2 txliab=txliab2 inctax=inctax2 taxaft=taxaft2

itded=itded2 nonit=nonit2 tabley=tabley2 exempt=exempt2
 newtxy=newtxy2  oldtxy=oldtxy2 zba=zba2 tax=tax2 regtax=regtax2
 margin=margin2 taxbc=taxbc2 nystax=nystax2 oystax=oystax2 

totitm=totitm2
sey=sey2  mxttly=mxttly2 mxnety=mxnety2 mxpref=mxpref2
 mrrdpy=mrrdpy2 mrrdsy=mrrdsy2 dweght=dweght2

agex=agex2 agexb=agexb2 
party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2
 ));
RUN;




 /* this program creates d3tall
(three year lag to reproduce Felstein)  */

libname bobo '/scratch/saez';




DATA bobo.d3tall82;
MERGE bobo.tall79 (IN=in1) bobo.dtall82 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall83;
MERGE bobo.tall80 (IN=in1) bobo.dtall83 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall84;
MERGE bobo.tall81 (IN=in1) bobo.dtall84 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall85;
MERGE bobo.tall82 (IN=in1) bobo.dtall85 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall86;
MERGE bobo.tall83 (IN=in1) bobo.dtall86 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall87;
MERGE bobo.tall84 (IN=in1) bobo.dtall87 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall88;
MERGE bobo.tall85 (IN=in1) bobo.dtall88 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall89;
MERGE bobo.tall86 (IN=in1) bobo.dtall89 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall90;
MERGE bobo.tall87 (IN=in1) bobo.dtall90 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN; 


DATA bobo.d3tall;
SET bobo.d3tall82 bobo.d3tall83 bobo.d3tall84
 bobo.d3tall85 bobo.d3tall86 bobo.d3tall87 bobo.d3tall88 bobo.d3tall89
 bobo.d3tall90;
IF mars=1 THEN mrs1=1;
ELSE mrs1=0;
IF mars=2 THEN mrs2=1;
ELSE mrs2=0;
IF mars>2 THEN mrs3=1;
ELSE mrs3=0;

IF flpdyr=79 THEN year79=1;
ELSE year79=0;
IF flpdyr=80 THEN year80=1;
ELSE year80=0;
IF flpdyr=81 THEN year81=1;
ELSE year81=0;
IF flpdyr=82 THEN year82=1;
ELSE year82=0;
IF flpdyr=83 THEN year83=1;
ELSE year83=0;
IF flpdyr=84 THEN year84=1;
ELSE year84=0;
IF flpdyr=85 THEN year85=1;
ELSE year85=0;
IF flpdyr=86 THEN year86=1;
ELSE year86=0;
IF flpdyr=87 THEN year87=1;
ELSE year87=0;
IF flpdyr=88 THEN year88=1;
ELSE year88=0;
IF flpdyr=89 THEN year89=1;
ELSE year89=0;

wagesr=wages/pce;
wages2r=wages2/pce2;
lnwag=LOG(wagesr);
dlogw=LOG(wages2r/wagesr);

broadr=broad/pce;
broad2r=broad2/pce2;
lnbroad=LOG(broadr);
dlogb=LOG(broad2r/broadr);


incefp=
LOG((broadr-(taxf1+taxs1)/pce)/(broadr-(taxf0+taxs0)/pce));
fincefp=
LOG((broadr-(taxf1)/pce)/(broadr-(taxf0)/pce));


inceff=
LOG((broad2r-(taxf02+taxs02)/pce2)/(broadr-(taxf0+taxs0)/pce));
finceff=
LOG((broad2r-(taxf02)/pce2)/(broadr-(taxf0)/pce));

incefp2=(-(taxf1+taxs1)/pce+(taxf0+taxs0)/pce)/broadr;
inceff2=(broad2r-(taxf02+taxs02)/pce2-broadr+(taxf0+taxs0)/pce)/broadr;

IF flpdyr<=80 OR flpdyr=82 OR flpdyr=83 THEN 
broadn=agi+ttladj+divrec-divagi+ui-uiagi-cgagi-cgdist;
IF flpdyr=81 THEN 
broadn=agi+ttladj+divrec+inty-divint+ui-uiagi-cgagi-cgdist;
IF flpdyr=84 OR flpdyr=85 OR flpdyr=86 THEN 
broadn=agi+ttladj+divrec-divagi-ssagi+ui-uiagi-cgagi-cgdist;
IF flpdyr>=87 THEN 
broadn=agi+ttladj-ssagi-cgagi-cgdist;

IF flpdyr2<=80 OR flpdyr2=82 OR flpdyr2=83 THEN 
broadn2=agi2+ttladj2+divrec2-divagi2+ui2-uiagi2-cgagi2-cgdist2;
IF flpdyr2=81 THEN 
broadn2=agi2+ttladj2+divrec2+inty2-divint2+ui2-uiagi2-cgagi2-cgdist2;
IF flpdyr2=84 OR flpdyr2=85 OR flpdyr2=86 THEN 
broadn2=agi2+ttladj2+divrec2-divagi2-ssagi2+ui2-uiagi2-cgagi2-cgdist2;
IF flpdyr2>=87 THEN 
broadn2=agi2+ttladj2-ssagi2-cgagi2-cgdist2;

fincbis=-taxf1+taxf0;
incbis=-taxf1-taxs1+taxf0+taxs0;


dlogbr=log(broadn2*pce/(broadn*pce2));
logbr=log(broadn/pce);


newtxr=newtxy/pce;
newtxr2=newtxr**2;
newtxr3=newtxr**3;
newtxr4=newtxr**4;
newtxr5=newtxr**5;


broad2=broadn**2;
broad3=broadn**3;
broad4=broadn**4;
broad5=broadn**5;


dmargp=LOG((100-ratef1-rates1)/(100-ratef0-rates0));
dmargt=LOG((100-ratef02-rates02)/(100-ratef0-rates0)); 
fdmargp=LOG((100-ratef1)/(100-ratef0));
fdmargt=LOG((100-ratef02)/(100-ratef0)); 

wdmargp=LOG((100-wratef1-wrates1)/(100-wratef0-wrates0));
wdmargt=LOG((100-wratef02-wrates02)/(100-wratef0-wrates0)); 
wfdmargp=LOG((100-wratef1)/(100-wratef0));
wfdmargt=LOG((100-wratef02)/(100-wratef0)); 
RUN;


DATA bobo.d3subset;
set bobo.d3tall;
if ID/50-ROUND(ID/50)=0;
run;


