* program for table 4;
#delimit;

log on;
* TABLE 4: ALL SAMPLE: BASIC ELASTICITIES WEIGHTED;
* TABLE WITH UNWEIGHTED INCOME EFFECTS INCLUDED;

log off;

gen marsi=0;
gen wegtt=2;
replace logbrav=0;replace logtavt=0;
replace logtavs=0;replace logtavc=0;
replace logtavm=0;
for num 79/88: gen yzX=yearX*logbr;
for num 79/88: gen yztX=yearX*logtct;
log on;
 * ALL MARS - INCOME CONTROLS: YEAR DUMMIES*LOG(INCOME), 10 LOG SPLINES, LOG INCOME;
log off;
run tab4; tab4;
run tab5; tab5;

for num 79/88 \ num 1/10: replace yztX=(flpdyr-79)*spltctY;
for num 79/88 \ num 1/10: replace yzX=(flpdyr-79)*splbroY;
log on;
 * ALL MARS - INCOME CONTROLS: 10 LOG SPLINES, LOG INCOME + TIME*LOGSPLINES ;
log off;
run tab4; tab4;
run tab5 ;tab5;

for num 79/88: replace yzX=0 \  replace yztX=0;
replace yzt79=(flpdyr-79)*logtct;
replace yz79=(flpdyr-79)*logbr;
log on;
 * ALL MARS - INCOME CONTROLS: 10 LOG SPLINES, LOG INCOME + TIME*LOGINCOME ;
log off;
run tab4; tab4;
run tab5;tab5;


for num 79/88: replace yztX=0;
for num 79/88: replace yzX=0;
log on;


log on;
 * ALL MARS - INCOME CONTROLS: 10 LOG SPLINES, LOG INCOME;
 * PREFERRED SPECIFICATION;
log off;
run tab4; tab4;
run tab5; tab5;


for num 1/10: replace splbroX=0 \ replace splwagX=0 \ replace spltctX=0;
replace logbrav=log(broav);replace logtavt=log(taxavt);
replace logtavs=log(taxavs);replace logtavc=log(taxavc);
replace logtavm=log(taxavm);
log on;
 * ALL MARS - INCOME CONTROLS: LOG (AVERAGE INCOME), LOG INCOME;
log off;

run tab4; tab4;
run tab5; tab5;

replace logbrav=0;replace logtavt=0;
replace logtavs=0;replace logtavc=0;
replace logtavm=0;
log on;
 * ALL MARS - INCOME CONTROLS:  LOG INCOME, ;
log off;
run tab4; tab4;
run tab5; tab5;

replace lnwag=0;replace logtct=0; replace logbr=0;
replace logtcs=0;replace logtcc=0;replace logtcm=0;
log on;
 * ALL MARS - INCOME CONTROLS:  NO CONTROLS;
log off;
run tab4; tab4;
run tab5; tab5;
